excalibur/website/forms/client.py
# Copyright (c) 2019 by Star Lab Corp.

from wtforms.fields import (StringField, TextAreaField, BooleanField,
                            SelectMultipleField)
from wtforms.fields.html5 import URLField
from wtforms.validators import DataRequired
from werkzeug.security import gen_salt
from .base import BaseForm
from ..services.oauth2 import scopes
from ..models import db, OAuth2Client

SCOPES = [(k, k) for k in scopes]
GRANTS = [('authorization_code', 'Authorization Code'),
          ('implicit', 'Implicit'), ('password', 'Password'),
          ('client_credentials', 'Client Credentials')]


class OAuth2ClientWrapper(object):
    def __init__(self, client):
        self._client = client
        self.name = client.name
        self.website = client.website
        self.is_confidential = client.is_confidential
        # self.redirect_uris = ''.join(client.redirect_uris)
        self.redirect_uris = '\n'.join(client.redirect_uris)
        self.default_redirect_uri = client.default_redirect_uri
        self.allowed_scopes = client.allowed_scopes.split()
        self.allowed_grants = client.allowed_grants.split()
        self.token_endpoint_auth_method = 'none'

        print('WAT    : REDIRECT_URIS - init    : %s' % self.redirect_uris)


class Client2Form(BaseForm):
    name = StringField(validators=[DataRequired()])
    website = URLField()
    is_confidential = BooleanField('Confidential Client')
    redirect_uris = TextAreaField()
    default_redirect_uri = URLField()
    allowed_scopes = SelectMultipleField(choices=SCOPES)
    allowed_grants = SelectMultipleField(choices=GRANTS)

    def update(self, client):
        client.name = self.name.data
        client.website = self.website.data
        client.is_confidential = self.is_confidential.data
        client.redirect_uris = self.redirect_uris.data.splitlines()
        client.token_endpoint_auth_method = 'none'
        # client.default_redirect_uri = self.default_redirect_uri.data
        print(self.redirect_uris.data)
        print(
            'WAT    : REDIRECT_URIS - update     : %s' % client.redirect_uris)
        client.allowed_scopes = ' '.join(self.allowed_scopes.data)
        client.allowed_grants = ' '.join(self.allowed_grants.data)
        with db.auto_commit():
            db.session.add(client)
        return client

    def save(self, user):
        name = self.name.data
        is_confidential = self.is_confidential.data

        client_id = gen_salt(48)
        if is_confidential:
            client_secret = gen_salt(78)
        else:
            client_secret = ''

        print(
            'WAT    : REDIRECT_URIS - save    : %s' % self.redirect_uris.data)

        client = OAuth2Client(
            user_id=user.id,
            client_id=client_id,
            client_secret=client_secret,
            name=name,
            is_confidential=is_confidential,
            default_redirect_uri=self.default_redirect_uri.data,
            website=self.website.data,
            allowed_scopes=' '.join(self.allowed_scopes.data),
            allowed_grants=' '.join(self.allowed_grants.data),
        )
        client.redirect_uris = self.redirect_uris.data.splitlines()
        client.token_endpoint_auth_method = 'none'
        with db.auto_commit():
            db.session.add(client)
        return client

excalibur/website/routes/client.py
# Copyright (c) 2019 by Star Lab Corp.

from flask import Blueprint, url_for
from flask import abort, redirect, render_template
from ..auth import require_login, current_user
from ..models import OAuth2Client
from ..forms.client import (Client2Form, OAuth2ClientWrapper)

bp = Blueprint('client', __name__)


@bp.route('')
@require_login
def list_clients():
    q = OAuth2Client.query.filter_by(user_id=current_user.id)
    oauth2_clients = q.order_by(OAuth2Client.id.desc()).limit(50).all()
    return render_template(
        'client/list.html',
        oauth2_clients=oauth2_clients,
    )


@bp.route('/<int:version>/create', methods=['GET', 'POST'])
@require_login
def create_client(version):
    form = Client2Form()

    if form.validate_on_submit():
        form.save(current_user)
        return redirect(url_for('.list_clients'))
    return render_template('client/create.html', form=form)


@bp.route('/<int:version>/<client_id>', methods=['GET', 'POST'])
@require_login
def edit_client(version, client_id):
    client = OAuth2Client.query.filter_by(client_id=client_id).first()
    print('WAT    : REDIRECT_URIS - bp.route    : %s' % ''.join(
        client.redirect_uris))
    if not client or client.user_id != current_user.id:
        abort(404)
    form = Client2Form(obj=OAuth2ClientWrapper(client))

    if form.validate_on_submit():
        form.update(client)
        return redirect(url_for('.list_clients'))
    return render_template('client/edit.html', form=form)

excalibur/website/templates/client/create.html
{% extends "base.html" %}
{% from "macros.html" import render_form %}

{% block body %}
  <section class="section">
    <div class="inner">
      <form class="mini-form" action="" method="post">
        {{ render_form(form) }}
        <button class="btn">Create</button>
      </form>
    </div>
  </section>
{% endblock %}

excalibur/website/templates/client/edit.html
{% extends "base.html" %}
{% from "macros.html" import render_form %}

{% block body %}
  <section class="section">
    <div class="inner">
      <form class="mini-form" action="" method="post">
        {{ render_form(form) }}
        <button class="btn">Update</button>
      </form>
    </div>
  </section>
{% endblock %}

excalibur/website/templates/client/list.html
{% extends "base.html" %}

{% block body %}
  <section class="section">
    <div class="inner">
      <a href="{{ url_for('client.create_client', version=2) }}" class="btn">New OAuth 2 App</a>
      <div class="divide"></div>
      <h2>OAuth 2 Apps</h2>
      {% for client in oauth2_clients %}
        <div class="client">
          <h3><a href="{{ url_for('client.edit_client', version=2, client_id=client.client_id) }}">{{ client.name }}</a>
          </h3>
          {% if client.website %}
            <p>{{ client.website }}</p>
          {% endif %}
          <ul>
            <li>Client ID: <strong>{{ client.client_id }}</strong></li>
            {% if client.client_secret %}
              <li>Client Secret: <strong>{{ client.client_secret }}</strong></li>
            {% endif %}
            <li>Scopes: {{ client.allowed_scopes }}</li>
            <li>Grants: {{ client.allowed_grants }}</li>
          </ul>
        </div>
      {% endfor %}
    </div>
  </section>
{% endblock %}